/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--				                 *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
/* Header Files */
#include "opengl.h"

/* Define Key */
#define XK_space                         0x0020
#define XK_Escape                        0xff1b
#define XK_F1                            0xffbe
#define XK_F2                            0xffbf
#define XK_F3							 0xffc0
#define XK_F4							 0xffc1
#define XK_Left                          0xff51  
#define XK_Up                            0xff52  
#define XK_Right                         0xff53  
#define XK_Down                          0xff54  
#define XK_a                             0x0061
#define XK_b                             0x0062
#define XK_d                             0x0064
#define XK_e                             0x0065
#define XK_q                             0x0071 
#define XK_s                             0x0073 
#define XK_w                             0x0077
#define XK_n                             0x006e
#define XK_m                             0x006d

/* Define Pi */
#define Pi 3.14159

/*-------------------------------------------------------------------------*/

/* Global Definitions */
char t;

GLfloat planeX;
GLfloat planeY;
GLfloat planeZ;
GLfloat rootY;
GLfloat viewZ;
GLfloat Display0;
GLfloat Display5;
GLfloat Display1;
GLfloat Display2;
GLfloat pitch;
GLfloat roll;
GLfloat yaw;

/* GLfloat xposition; */
/* GLfloat zposition; */
/* GLfloat yrotation; */

/* RGB Colour */
float VA0;
float VA1;    
float VA5;
float VA10;

/* Init Triangles */
GLfloat x;
GLfloat y;
GLfloat z;
	
/* 4 Landscapes Files */
FILE *landsc1;
FILE *landsc2;
FILE *landsc3;
FILE *landsc4;
FILE *setting;

/* RGB Colour */
GLfloat r;
GLfloat	g;
GLfloat	b;
GLfloat	a;

/*---------------------------------------------------------------------------*/

/* Init Triangles */
void init(char night)
{	
	/* Background Color */
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	if(night)
	{
		glClearColor( 0.1f , 0.1f , 0.1f , 1.0f );
	}
	else
	{
		glClearColor( 0.0f , 0.4f , 0.7f , 1.0f );
	}
}

/*---------------------------------------------------------------------------*/

/* Render Landscape */
void renderLandscape(char colour)
{
	/* Render Triangles */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	glTranslatef(0.0f, 0.0f, 0.0f);

	/* Camera Look */
	gluLookAt(0.0f, 0.0f,  25.0f, 
		 	  0.0f, 0.0f, -25.0f, 
		 	  0.0f, 5.0f,  0.0f);

	/* Rotation */
	glRotatef(-roll, 0.0f, 0.0f, 0.4f);
	glRotatef(-yaw, 0.0f, 0.4f, 0.0f);
	glRotatef(-pitch, 0.4f, 0.0f, 0.0f);
        
	glTranslatef(-planeX, -planeY, -planeZ);
	
	if(colour)
	{
		setting=fopen("DATA/setting1.fs","r");
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	}
	else
	{
		setting=fopen("DATA/setting2.fs","r");
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	}
	
	/* Begin Triangles */
	glBegin(GL_TRIANGLES);
	
	landsc1=fopen("DATA/landsc1.fs","r");
	landsc2=fopen("DATA/landsc2.fs","r");
	landsc3=fopen("DATA/landsc3.fs","r");
	landsc4=fopen("DATA/landsc4.fs","r");
	
	fscanf(setting,"%s %f %f %f ", &t, &r, &g, &b);
	glColor3f( r , g , b );	
	while((fscanf(landsc1,"%f %f %f", &x, &y, &z)) != EOF)
	{ 
		//printf("%02ff , %02ff , %02ff\n", x, y, z); 
		glVertex3f( (x - 30) , y , (z - 30) );
	}
		
	fscanf(setting,"%s %f %f %f ", &t, &r, &g, &b);
	glColor3f( r , g , b );		
	while((fscanf(landsc2,"%f %f %f", &x, &y, &z)) != EOF)
	{
		glVertex3f( (x - 30) , y , (z + 30) );
	}
	
	fscanf(setting,"%s %f %f %f ", &t, &r, &g, &b);
	glColor3f( r , g , b );	
	while((fscanf(landsc3,"%f %f %f", &x, &y, &z)) != EOF)
	{
		glVertex3f( (x + 30) , y , (z - 30) );
	}

	fscanf(setting,"%s %f %f %f ", &t, &r, &g, &b);
	glColor3f( r , g , b );	
	while((fscanf(landsc4,"%f %f %f", &x, &y, &z)) != EOF)
	{
		glVertex3f( (x + 30) , y , (z + 30) );
	}
	
	/* End Triangles */	
	fclose(landsc1);
	fclose(landsc2);
	fclose(landsc3);
	fclose(landsc4);
	fclose(setting);
	glEnd();
}

/*-------------------------------------------------------------------------*/

/* Render Plane */
void renderPlane()
{
	/* Render Triangles */
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	/* Begin Triangles */
	glBegin(GL_TRIANGLES);
		
		/* Plane 1 */
		glColor3f( 0.0f, 0.0f, 1.0f);
		glVertex3f(-0.5f, 2.5f, 0.2f );
		glVertex3f(-0.2f, 2.5f,-0.5f );
		glVertex3f( 0.5f, 2.5f, 0.2f );
		
		glVertex3f( 0.0f, 2.7f, 0.2f );
		glVertex3f(-0.2f, 2.5f,-0.5f );
		glVertex3f( 0.0f, 2.5f, 0.2f );
		
		/* Plane 2 */
		glColor3f( 0.0f, 1.0f, 0.0f);
		glVertex3f(-4.5f, 4.5f,-4.2f );
		glVertex3f(-4.2f, 4.5f,-4.5f );
		glVertex3f(-3.5f, 4.5f,-4.2f );
		
		glVertex3f(-4.0f, 4.7f,-4.2f );
		glVertex3f(-4.2f, 4.5f,-4.5f );
		glVertex3f(-4.0f, 4.5f,-4.2f );
		
		/* Plane 3 */
		glColor3f( 0.0f, 0.0f, 1.0f);
		glVertex3f( 15.5f, 3.0f, 15.2f );
		glVertex3f( 15.2f, 3.0f, 15.5f );
		glVertex3f( 14.5f, 3.0f, 15.2f );
		
		glVertex3f( 15.0f, 3.2f, 15.2f );
		glVertex3f( 15.2f, 3.0f, 15.5f );
		glVertex3f( 15.0f, 3.0f, 15.2f );
		
	/* End Triangles */
	glEnd();
}

/*-------------------------------------------------------------------------*/

/* Render Cockpit */
void renderCockpit()
{
	/* Rotation */
	glRotatef(roll, 0.0f, 0.0f ,0.1f);
	glRotatef(yaw, 0.0f, 0.1f ,0.0f);
	glRotatef(pitch, 0.1f, 0.0f ,0.0f);

	glTranslatef(planeX, planeY, planeZ + viewZ + 23.499f);
    
	/* Render Cockpit */
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	/* Begin Quads */
	glBegin(GL_QUADS);
	
		/* Cockpit */
		glColor4f( 0.9f, 0.9f, 0.9f, 1.0f);
		glVertex3f(-0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f,  0.3f, 0.3f );
		glVertex3f(-0.3f,  0.3f, 0.3f );
		
		glColor4f( 0.0 +VA10, 1.0 -VA5, 0.0 +VA0, 1.0 +VA0);		
		glVertex3f(-0.5f, -0.5f, 0.0f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f( 0.5f,  0.5f, 0.0f );
		glVertex3f(-0.5f,  0.5f, 0.0f );
		
		glVertex3f(-0.7f, -0.5f, 1.5f );
		glVertex3f( 0.7f, -0.5f, 1.5f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f(-0.5f, -0.5f, 0.0f );
		
		glVertex3f(-0.7f,  0.5f, 1.5f );
		glVertex3f( 0.7f,  0.5f, 1.5f );
		glVertex3f( 0.5f,  0.5f, 0.0f );
		glVertex3f(-0.5f,  0.5f, 0.0f );
		
		/* Terminal */
		glColor4f( 0.9f, 0.9f, 0.9f, 1.0f);
		glVertex3f(-1.0f, 1.09f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 1.09f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 1.05f + rootY, 0.5f -viewZ );
		glVertex3f(-1.0f, 1.05f + rootY, 0.5f -viewZ );
		
		glVertex3f(-1.0f, 0.64f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 0.64f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 0.60f + rootY, 0.5f -viewZ );
		glVertex3f(-1.0f, 0.60f + rootY, 0.5f -viewZ );
		
	/* End Quads */
	glEnd();
	
	/* Render Quads */
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	/* Begin Quads */
	glBegin(GL_QUADS);
		
		/* Instruments */
		glColor4f(1.0f +VA0 ,1.0f -VA5 ,1.0f -VA10,0.4f -VA1);
		glVertex3f(-0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f,  0.3f, 0.3f );
		glVertex3f(-0.3f,  0.3f, 0.3f );
		
		glColor4f( 0.2f, 0.2f, 0.2f, 1.0f);
		glVertex3f(-0.7f, -0.5f, 1.5f );
		glVertex3f( 0.7f, -0.5f, 1.5f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f(-0.5f, -0.5f, 0.0f );
		
		glVertex3f( 0.7f, 0.5f, 1.5f );
		glVertex3f(-0.7f, 0.5f, 1.5f );
		glVertex3f(-0.5f, 0.5f, 0.0f );
		glVertex3f( 0.5f, 0.5f, 0.0f );
		
		/* Terminal */
		glColor4f( 0.2f, 0.3f, 0.4f, 1.0f);
		glVertex3f(-1.0f, 0.60f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 0.60f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 0.64f + rootY, 0.5f -viewZ );
		glVertex3f(-1.0f, 0.64f + rootY, 0.5f -viewZ );
		
		glVertex3f(-1.0f, 1.09f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 1.09f + rootY, 0.5f -viewZ );
		glVertex3f( 1.0f, 1.05f + rootY, 0.5f -viewZ );
		glVertex3f(-1.0f, 1.05f + rootY, 0.5f -viewZ );
		
		glColor4f( 0.0f, 0.0f, 0.0f, 1.0f);
		glVertex3d(-1.0f, 0.6f + rootY, 0.5f -viewZ );
		glVertex3d( 1.0f, 0.6f + rootY, 0.5f -viewZ );
		glVertex3d( 1.0f, 1.1f + rootY, 0.5f -viewZ );
		glVertex3d(-1.0f, 1.1f + rootY, 0.5f -viewZ );
		
		/* Night Look */
		glColor4f( 0.0f, 1.0f, 0.0f, 0.3f);
		glVertex3d(-1.0f,-1.0f, 1.0f );
		glVertex3d( 1.0f,-1.0f, 1.0f );
		glVertex3d( 1.0f, 1.0f, 1.0f );
		glVertex3d(-1.0f, 1.0f, 1.0f );
		
	/* End Quads */
	glEnd();
}

/*-------------------------------------------------------------------------*/

/* Process Event */
void process_event(XEvent report)
{   
	KeySym key;
	key = XLookupKeysym (&report.xkey, 0);
		
	switch(key)
	{		
		case XK_Up:
		pitch -= 0.2f;
		break;
		
		case XK_Down:
		pitch += 0.2f;
		break;
		
		case XK_Left:
		roll += 0.5f;
		break;
		
		case XK_Right:
		roll -= 0.5f;
		break;
		
		case XK_a:
		planeX -= 0.05f;
		break;
		
		case XK_d:
		planeX += 0.05f;
		break;
		
		case XK_w:
		planeY += 0.04f;
		break;
		
		case XK_s:
		planeY -= 0.04f;
		break;
		
		case XK_e:
		yaw += 0.2f;
		break;
		
		case XK_q:
		yaw -= 0.2f;
		break;
		
		case XK_b:
		planeZ += 0.06f;
		break;
		
		case XK_space:
		planeZ -= 0.06f;
		break;
		
		case XK_m:
		viewZ = 0.0f;
		break;
		
		case XK_n:
		viewZ = -0.5f;
		break;
		
		case XK_F1:
		rootY = -0.6f;
		break;
		
		case XK_F2:
		rootY = +0.6f;
		break;
		
		case XK_F3:
		VA0 = +0.0f;
		VA1 = -0.1f;
		VA5 = +0.5f;
		VA10 = +1.0f;
		break;
		
		case XK_F4:
		VA0 = -0.0f;
		VA1 = +0.1f;    
		VA5 = -0.5f;
		VA10 = -1.0f;
		break;
		
		/* Close Window */
		case XK_Escape:
		closeWin();
		break;
	}
}

/*---------------------------------------------------------------------------*/
